config/routes.rb
Rails.application.routes.draw do
  

  get 'logout' => 'sessions#logout'
  get 'login' => 'sessions#login'
  post 'login_process' => 'sessions#login_process'
  get 'welcome_user' => 'sessions#welcome_user'
  get 'project_search' => 'projects#project_search'


  resources :projects
  resources :categories
  resources :users
  
  root 'sessions#login'
  
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/category.rb
class Category < ApplicationRecord
   validates :category_name, presence: true, uniqueness: true
end

app/models/project.rb
class Project < ApplicationRecord
  belongs_to :user
  belongs_to :category
  validates :project_name, presence: true, uniqueness: { scope: :category_id }
  include PgSearch::Model
      pg_search_scope :search_by_project_name, :against => :project_name, 
      	using: {
      		tsearch: {

      			prefix: true,
      			highlight: {
        			start_sel: '<b>',
        			stop_sel: '</b>',
		      	}

      		}
      	}
end

app/models/user.rb
class User < ApplicationRecord
	
   require 'bcrypt'

   has_secure_password

   has_many :projects

   validates_uniqueness_of :email_id, :message => "Already Exists"

   def user_full_name
    	"#{first_name} #{last_name}"
   end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # protect_from_forgery with: :exception

  before_action :check_session
  helper_method :current_user

  def check_session
    redirect_to login_path unless current_user
  end

  private

  def current_user
    @current_user ||= User.find(session[:user_id]) if session[:user_id]
  end

end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: [:show, :edit, :update, :destroy]

  # GET /categories
  # GET /categories.json
  def index
    @categories = Category.all
  end

  # GET /categories/1
  # GET /categories/1.json
  def show
  end

  # GET /categories/new
  def new
    @category = Category.new
  end

  # GET /categories/1/edit
  def edit
  end

  # POST /categories
  # POST /categories.json
  def create
    @category = Category.new(category_params)

    respond_to do |format|
      if @category.save
        format.html { redirect_to @category, notice: 'Category was successfully created.' }
        format.json { render :show, status: :created, location: @category }
      else
        format.html { render :new }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /categories/1
  # PATCH/PUT /categories/1.json
  def update
    respond_to do |format|
      if @category.update(category_params)
        format.html { redirect_to @category, notice: 'Category was successfully updated.' }
        format.json { render :show, status: :ok, location: @category }
      else
        format.html { render :edit }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /categories/1
  # DELETE /categories/1.json
  def destroy
    @category.destroy
    respond_to do |format|
      format.html { redirect_to categories_url, notice: 'Category was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def category_params
      params.require(:category).permit(:category_name)
    end
end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: [:show, :edit, :update, :destroy]

  # GET /projects
  # GET /projects.json
  def index
    @projects = Project.all
  end

  def project_search
	@projects = params["category"].present? ? Project.where(category_id: params["category"]) : Project.all 
	@projects = params["search_params"].length > 0 && params["search_params"].present? ? @projects.search_by_project_name(params["search_params"]) : @projects
  end


  # GET /projects/1
  # GET /projects/1.json
  def show
  end

  # GET /projects/new
  def new
    @project = Project.new
  end

  # GET /projects/1/edit
  def edit
  end

  # POST /projects
  # POST /projects.json
  def create
    @project = Project.new(project_params)

    respond_to do |format|
      if @project.save
        format.html { redirect_to projects_url notice: 'Project was successfully created.' }
        format.json { render :index, status: :created, location: @projects }
      else
        format.html { render :new }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /projects/1
  # PATCH/PUT /projects/1.json
  def update
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to projects_url, notice: 'Project was successfully updated.' }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1
  # DELETE /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to projects_url, notice: 'Project was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def project_params
      params.require(:project).permit! #(:project_name, :description, :user_id, :category_id)
    end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  skip_before_action :check_session, only:[:login, :login_process]


  def login
	render :layout => false
  end

  def login_process
	user = User.find_by(email_id: params["email_id"])
	if user && user.authenticate(params["password"])
		session[:user_id] = user.id
		redirect_to welcome_user_path
	else
		redirect_to root_url, alert: "Invalid Username or Password"
	end
  end

  def logout
	session[:user_id] = nil
  	redirect_to login_path
  end

  def welcome_user
	@user = current_user
  end

end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]
  skip_before_action :check_session, only:[:create, :new]

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to login_path, notice: 'User was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: 'User was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def user_params
      params.require(:user).permit! #(:first_name, :last_name, :email_id, :password_digest)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/helpers/sessions_helper.rb
module SessionsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/categories/_form.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">

<%= form_with(model: category, local: true) do |form| %>
  <% if category.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(category.errors.count, "error") %> prohibited this category from being saved:</h2>

      <ul>
      <% category.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="container">
   <div class="row">
     <div class="col-4 form-group row">
        <div class="col-md-4">
           <%= form.label :category_name %>
        </div>
        <div class="col-md-8">
	   <%= form.text_field :category_name, id: :category_category_name %>
        </div>
     </div>
   </div>
   <div class="actions">
      <%= form.submit "Submit", class:"btn btn-primary float-right" %>
      <%= link_to "Cancel", categories_path, class: "btn btn-warning float-right mr-3" %> 
   </div>
  </div>
<% end %>

app/views/categories/edit.html.erb
<h1>Editing Category</h1>

<%= render 'form', category: @category %>

<%= link_to 'Show', @category, class: "btn btn-info float-right mr-3" %> 

app/views/categories/index.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>

<div style="margin-top: 50px" class="row page-titles">
    <div class="col-md-5 align-self-center">
        <h3 class="text-primary">Categories</h3>
    </div>
</div>

<br>
<div class="container">
  <div class="card top">
    <div class="row">
      <div class="col-md-3 pull-left">
	<%= button_to "New", {action: "new"}, :method => :get, class: "btn btn-primary", id: "new_btn_id"%>
      </div>
      <div class="col-md-3 pull-left">
	<%= button_to "Back", {action: "welcome_user", :controller=>"sessions"}, :method => :get, class: "btn btn-warning", id: "back_btn_id"%>
      </div>
    </div>

    <div id="project_list">
      <% if @categories.present? %>
	<table id="category_list" class="table table-striped display" cellspacing="0" width="100%">
	  <thead>
	    <tr>
	      <th>Category name</th>
	      <th colspan="3"></th>
	    </tr>
	  </thead>

	  <tbody>
	    <% @categories.each do |category| %>
	      <tr>
	        <td><%= category.category_name %></td>
	        <td><%= link_to 'Show', category %></td>
	        <td><%= link_to 'Edit', edit_category_path(category) %></td>
	        <td><%= link_to 'Destroy', category, method: :delete, data: { confirm: 'Are you sure?' } %></td>
	      </tr>
	    <% end %>
	  </tbody>
	</table>
      <% else %>
	 <tr><div class="search_result"><p><i class="fa fa-search" aria-hidden="true"> No Record Found</i></p></div></tr>
      <% end %>
    </div>
  </div>
</div>

<script type="text/javascript">
  $(document).ready(function(){
    
    $('#category_list').dataTable();
 });
</script>

app/views/categories/new.html.erb
<h1>New Category</h1>

<%= render 'form', category: @category %>

<%= link_to 'Back', categories_path %>

app/views/categories/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Category name:</strong>
  <%= @category.category_name %>
</p>


<%= link_to 'Edit', edit_category_path(@category), class: "btn btn-danger float-right mr-3" %> 
<%= link_to 'Back', categories_path, class: "btn btn-warning float-right mr-3" %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>AuctionTask</title>
    <%= csrf_meta_tags %>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/projects/_form.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">


<%= form_with(model: project, local: true) do |form| %>
  <% if project.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(project.errors.count, "error") %> prohibited this project from being saved:</h2>

      <ul>
      <% project.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

<div class="container">  
  <div class="row">
     <div class="col-4 form-group row">
	<div class="col-md-4">
	   <%= form.label :project_name %>
	</div>
	<div class="col-md-8">
	   <%= form.text_field :project_name, id: :project_project_name, required: true %>
	</div>
     </div>
  </div>
  
  <div class="row">
     <div class="col-6 form-group row">
        <div class="col-md-4">
	   <%= form.label :description %>
        </div>
        <div class="col-md-8">
           <%= form.text_field :description, id: :project_description %>
       </div>
     </div>
  </div>
  
  <div class="row">
     <div class="col-6 form-group row">
        <div class="col-md-4">
           <%= form.label :category_id, "Project Category" %>
        </div>
        <div class="col-md-8">
           <%= form.collection_select(:category_id,Category.all, :id,:category_name, {prompt: true}, {id: :category_dropdown}) %>
        </div>
     </div>
  </div>

  <%= form.hidden_field :user_id, value: current_user.id  %>

  <div class="actions">
    <%= form.submit "Submit", class:"btn btn-primary float-right" %>
    <%= link_to "Cancel", projects_path, class: "btn btn-warning float-right mr-3" %>
  </div>
</div>
<% end %>

app/views/projects/_project_search.html.erb
<div id="project_filter_list">
      <% if @projects.present? %>
        <table id="project_filter_table" class="table table-striped display" cellspacing="0" width="100%">
          <thead>
            <tr>
              <th>Project name</th>
              <th>Description</th>
              <th>User</th>
              <th>Category</th>
              <th colspan="3"></th>
            </tr>
          </thead>
          <tbody>
            <% @projects.each do |project| %>
              <tr>
                <td><%= project.project_name %></td>
                <td><%= project.description %></td>
                <td><%= project.user.first_name %></td>
                <td><%= project.category.category_name %></td>
                <td><%= link_to 'Show', project %></td>
                <td><%= link_to 'Edit', edit_project_path(project) %></td>
                <td><%= link_to 'Destroy', project, method: :delete, data: { confirm: 'Are you sure?' } %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      <% else %>
        <tr><div class="search_result"><p><i class="fa fa-search" aria-hidden="true"> No Record Found</i></p></div></tr>
      <% end %>
</div>

app/views/projects/edit.html.erb
<h1>Editing Project</h1>

<%= render 'form', project: @project %>

<%= link_to 'Show', @project, class: "btn btn-info float-right mr-3" %> 

app/views/projects/index.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script> 
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"> </script>

<br>
<div style="margin-top: 50px" class="row page-titles">
    <div class="col-md-5 align-self-center">
        <h3 class="text-primary">Projects</h3>
    </div>
</div>

<div class="container">
  <div class="card top">
    <div class="row">
      <div class="col-md-3 pull-left">
	<%= select_tag "category", options_from_collection_for_select(Category.all, "id", "category_name"), {prompt: 'Select Cateogory', id: 'category'} %>
      </div>
      <div class="col-md-2 pull-left">
	<input id="search_params" name="search" placeholder="Enter the Project name" type="text" />
      </div>

<!--      <div class="col-md-2 pull-left">
	<button id="submit_btn" class="btn btn-success col submit-btn"  type="submit">Submit</button>
      </div> -->

      <div class="col-md-3 pull-left">
        <%= button_to "New", {action: "new"}, :method => :get, class: "btn btn-primary", id: "new_btn_id"%>
      </div>
      <div class="col-md-3 pull-left">
	<%= button_to "Back", {action: "welcome_user", :controller=>"sessions"}, :method => :get, class: "btn btn-warning", id: "back_btn_id"%>
      </div>

    </div>

    <div id="project_list">
      <% if @projects.present? %>
        <table id="project_list_table" class="table table-striped display" cellspacing="0" width="100%">
          <thead>
            <tr>
              <th>Project name</th>
              <th>Description</th>
              <th>User</th>
              <th>Category</th>
              <th colspan="3"></th>
            </tr>
          </thead>
          <tbody>
            <% @projects.each do |project| %>
              <tr>
                <td><%= project.project_name %></td>
                <td><%= project.description %></td>
                <td><%= project.user.first_name %></td>
                <td><%= project.category.category_name %></td>
                <td><%= link_to 'Show', project %></td>
                <td><%= link_to 'Edit', edit_project_path(project) %></td>
                <td><%= link_to 'Destroy', project, method: :delete, data: { confirm: 'Are you sure?' } %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      <% else %>
        <tr><div class="search_result"><p><i class="fa fa-search" aria-hidden="true"> No Record Found</i></p></div></tr>
      <% end %>
    </div>
    
    <div id="project_filter_list">

    </div>
  </div>
</div>

<script type="text/javascript">
  $(document).ready(function(){
    $('#project_listi').dataTable();
    
    $("#category").on('change', function(){
      var category = ($("#category").val());
      var search_params = ($("#search_params").val());
        $.ajax({
          type: "GET",
           url: "project_search?category="+category+"&&search_params="+search_params,
           data: {category: category, search_params: search_params},
           success: function(data) {
                window.alert("success!!");
           },
           error: function (){
                window.alert("something wrong!");
           }
        })
    })


    $("#search_params").keyup(function(){
      var category = ($("#category").val());
      var search_params = ($("#search_params").val());
        $.ajax({
          type: "GET",
           url: "project_search?category="+category+"&&search_params="+search_params,
           data: {category: category, search_params: search_params},
           success: function(data) {
                window.alert("success!!");
           },
           error: function (){
                window.alert("something wrong!");
           }
        })    
    })


   //  $('#submit_btn').click(function(){
   //    var category = ($("#category").val());
   //    var search_params = ($("#search_params").val());
   //      $.ajax({
   //        type: "GET",
   //         url: "project_search?category="+category+"&&search_params="+search_params,
   //	   data: {category: category, search_params: search_params},
   //	   success: function(data) {
   //		window.alert("success!!");
   //	   },
   //	   error: function (){
   // 		window.alert("something wrong!");
   //	   }
   //      })
   //  })
  });
</script>

app/views/projects/new.html.erb
<h1>New Project</h1>

<%= render 'form', project: @project %>

app/views/projects/project_search.js.erb
$("#project_list_table").html("<%= escape_javascript(render 'projects/project_search') %>");

app/views/projects/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Project name:</strong>
  <%= @project.project_name %>
</p>

<p>
  <strong>Description:</strong>
  <%= @project.description %>
</p>

<p>
  <strong>User:</strong>
  <%= @project.user.first_name %>
</p>

<p>
  <strong>Category:</strong>
  <%= @project.category.category_name %>
</p>

<%= link_to 'Edit', edit_project_path(@project), class: "btn btn-danger float-right mr-3" %> 
<%= link_to "Back", projects_path, class: "btn btn-warning float-right mr-3" %>

app/views/users/_form.html.erb
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"><link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">

<%= form_with(model: user, local: true) do |form| %>
  <% if user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  <div class="container">
  <div class="form-group row">
     <div class="col-md-5">
	<%= form.label :first_name, class: "col-form-label" %>
	<%= form.text_field :first_name, id: :user_first_name, class: "form-control", required: true %>
     </div>
     
     <div class="col-md-5">
	<%= form.label :last_name, class: "col-form-label" %>
        <%= form.text_field :last_name, id: :user_last_name, class: "form-control", required: true %>
     </div>

     <div class="col-md-5">
	<%= form.label :email_id, class: "col-form-label" %>
	<%= form.text_field :email_id, id: :user_email_id, class: "form-control", required: true %>
     </div>
    
     <div class="col-md-5">
	<%= form.label :password, class: "col-form-label" %>
	<%= form.password_field :password, id: "password-field", class: "form-control", required: true %>
     </div> 
  </div>
     <div class="actions col-md-12 mt-4">
        <%= form.submit "Submit", class:"btn btn-primary float-right" %>
	<%= link_to "Cancel", login_path, class: "btn btn-warning float-right mr-3" %>
     </div>
  </div>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form', user: @user %>

<%= link_to 'Show', @user %> |

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Users</h1>

<table>
  <thead>
    <tr>
      <th>First name</th>
      <th>Last name</th>
      <th>Email</th>
      <th>Password digest</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.first_name %></td>
        <td><%= user.last_name %></td>
        <td><%= user.email_id %></td>
        <td><%= user.password_digest %></td>
        <td><%= link_to 'Show', user %></td>
        <td><%= link_to 'Edit', edit_user_path(user) %></td>
        <td><%= link_to 'Destroy', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New User', new_user_path %>

app/views/users/new.html.erb
<h1>User Registration</h1>

<%= render 'form', user: @user %>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>First name:</strong>
  <%= @user.first_name %>
</p>

<p>
  <strong>Last name:</strong>
  <%= @user.last_name %>
</p>

<p>
  <strong>Email:</strong>
  <%= @user.email_id %>
</p>

<p>
  <strong>Password digest:</strong>
  <%= @user.password_digest %>
</p>

<%= link_to 'Edit', edit_user_path(@user), class: "btn btn-danger float-right mr-3" %> |
<%= link_to 'Back', users_path, class: "btn btn-warning float-right mr-3" %>